function AICC_NAV(){
	this.ActualPg=null;
	this.ActualAp=null;
	this.ActualBl=null;
	this.Progress=null;
	this.TipoNav="normal";
	this.RagNav="";
	this.paginaSiguiente=null;
	this.paginaAnterior=null;
}


function _Acceso(){
	if (SCO.getDataConfig("curso", "lastPag")=="true"){
	    var tmpPagina=SCO.DATA.LastPage;
	    
	    if (tmpPagina){
	    
	    if ((!tmpPagina) || (tmpPagina=="")||(tmpPagina==undefined)||(tmpPagina=="-")) {
	    
	    	if (SCO.getDataConfig("curso", "pagInit")=="true"){
		    this.IrPagina("paginaInicio")
		}
		else {
		    SCO.DATA.curso.IrFirst();
		}
	    }
	    else{
	    
	    	  var aux=SCO.DATA.NEXFindItem(tmpPagina);
	    	  if (aux!=false) aux.Acceso();
	    }
	  }
	else{
	 SCO.DATA.curso.IrFirst();
	}
	}
	else{	
		if (SCO.getDataConfig("curso", "pagInit")=="true"){
		    this.IrPagina("paginaInicio")
		}
		else {
		     SCO.DATA.curso.IrFirst();
		}
	}
}

function _IrPagina(param){
	SCO.DATA.LastPage=param;
	this.ActualPg=SCO.DATA.NEXFindItem(param);
}

function _getPaginacion(){
	var ans=new Array(3);
   	var paginaActual=this.ActualPg.name.toLowerCase();
   	//Calculo de las agrupaciones superiores.
   	var aux=paginaActual.split("_")
   	
	var bloqueActual="b"+aux[0].substring(1,aux[0].length)
	var subBloqueActual = bloqueActual +"_"+ aux[1];
	var numPag = new String("");
   	var total  = new String("");

	var sigPag=this.Avanzar(paginaActual);
	
	var antPag=this.Retroceder(paginaActual);
	
	//Se comprueba se los elementos obtenidos estan o no en el rango establecido.
		
		if (sigPag) sigPag=this.ExisteEnRango(sigPag);
		else sigPag="";
		
		if (antPag) antPag=this.ExisteEnRango(antPag);
		else antPag="";
		
		//Siguiente:
		if (sigPag!=""){
			this.paginaSiguiente=sigPag;
			ans[1]=1;
		}
		else{
			this.paginaSiguiente="";
			ans[1]=0;
		}
		
		//Anterior
		if (antPag!=""){
			this.paginaAnterior=antPag;
			ans[2]=1;
		}
		else{
			this.paginaAnterior="";
			ans[2]=0;
		}
		//Numeracion
		ans[0]="-/-"
		//Si la paginacion es por bloque:
		if (SCO.getDataConfig(bloqueActual, "paginacion")=="blq"){
			numPag = Number(SCO.DATA.NEXTotalPrevBlocPages(paginaActual))+1; 
			total  = SCO.DATA.NEXTotalPagesBloc(bloqueActual); 
			
			
			
			
			ans[0]=numPag+"/"+total
		} //Si la paginacion es por apartado
		else {
			numPag = Number(SCO.DATA.NEXOrder(paginaActual)); 
   			total  = SCO.DATA.NEXTotalPages(subBloqueActual);
   			ans[0]=numPag+"/"+total
		}
		
		//Correccion de la botonera:
		if (SCO.getDataConfig("curso", "paginacion")!="curso"){
			if (numPag==1) ans[2]=0;         //--> Si estamos en la primera pagina no hay anterior
			else if (numPag==total)ans[1]=0; //--> Si estamos en la ultima pagina no hay siguiente
		}
		//if ((SCO.getDataConfig(subBloqueActual, "tipo")=="eva")||(SCO.getDataConfig(subBloqueActual, "tipo")=="cas")||(SCO.getDataConfig(subBloqueActual, "tipo")=="act")) ans[2]=0; //--> En las evaluaciones, casos o actividades no se puede ir hacia atras. 
		if (paginaActual.substr(0,1).toUpperCase()=="A") { //-->Si estamos en una actividad 
			if ((SCO.DATA.NEXStatus(paginaActual).toUpperCase()=="N")||(SCO.DATA.NEXStatus(paginaActual).toUpperCase()=="I")) ans[1]=0;  //--> Y la actividad no esta realizada aun, no se puede avanzar.
		}

   	    
   	return ans;

}

function _Retroceder(pA){
	var tmpPagina = new String("");
	var tempPosition=pA.split("_");
	var profundidad=tempPosition.length;
	var antApartado;
	var i;
	var aux;
	
	tempPosition[0]="B"+tempPosition[0].substring(1,tempPosition[0].length); //Bloque Actual
	i=profundidad-2; //Apartado de mayor nivel (-1 por paginas de contenido y -1 pq array empieza en 0)
	tmpPagina = SCO.DATA.NEXGoPrev(pA); //Pagina siguiente (supuesta)
	
	//Si no encuentra pagina anterior busca en apartado/bloque anterior
	while ((tmpPagina=="") && (i>=0)){
		aux="";
		for (j=0;j<=i;j++) aux = aux + (aux==""?"":"_") + tempPosition[j]; //Bloque + Apartados + subApartados
		
		antApartado=SCO.DATA.NEXGoPrevBlock(aux);
		if (antApartado!="") {
			tmpPagina=SCO.DATA.NEXLast(antApartado);
			//Control cambio de bloque
			for (j=i;j<profundidad-2;j++) tmpPagina = SCO.DATA.NEXLast(tmpPagina);
		}
		i=i-1;
	}
	//alert("RETROCEDER\nPagina anterior a "+pA+" = "+tmpPagina)
	return tmpPagina.toLowerCase();
}


function _Avanzar(pA){
	
	var tmpPagina = new String("");
	var tempPosition=pA.split("_");
	var profundidad=tempPosition.length;
	var sigApartado;
	var i;
	var aux;
	var aux2;
	
	tempPosition[0]="B"+tempPosition[0].substring(1,tempPosition[0].length); //Bloque Actual
	i=profundidad-2; //Apartado de mayor nivel (-1 por paginas de contenido y -1 pq array empieza en 0)
	if (this.TipoNav=="normal") tmpPagina = SCO.DATA.NEXGoNext(pA); //Pagina siguiente (supuesta)
	else if (this.TipoNav=="notAttem") tmpPagina = SCO.DATA.NEXNextNoAttepActivity(pA); //Pagina siguiente (supuesta)
	
	if (this.TipoNav=="normal"){
		//Si no encuentra pagina siguiente busca en apartado/bloque siguiente
		while ((tmpPagina=="") && (i>=0)){
			aux="";
			for (j=0;j<=i;j++) aux = aux + (aux==""?"":"_") + tempPosition[j]; //Bloque + Apartados + subApartados
			
			sigApartado = SCO.DATA.NEXGoNextBlock(aux);
			if (sigApartado!="") {
				tmpPagina=SCO.DATA.NEXFirst(sigApartado);
				//Control cambio de bloque
				for (j=i;j<profundidad-2;j++) tmpPagina = SCO.DATA.NEXFirst(tmpPagina);
			}
			i=i-1;
		}
	}
	else if (this.TipoNav=="notAttem") {
			//if (getDataConfig(bloqueActual, "paginacion")=="blq"){
		while ((tmpPagina=="") && (i>=0)){
			aux="";
			for (j=0;j<=i;j++) aux = aux + (aux==""?"":"_") + tempPosition[j]; //Bloque + Apartados + subApartados
			aux2=SCO.getDataConfig(aux, "tipo"); //Determina el tipo de apartado (subapartado en el que estamos)
			if ((aux2.toLowerCase()=="eva")||(aux2.toLowerCase()=="cas")) {
				tmpPagina=SCO.DATA.NEXLast(aux);
				var item_pagina = SCO.DATA.NEXFindItem(tmpPagina);
				//if (tmpPagina.toLowerCase()==pA.toLowerCase()){
				if (tmpPagina.toLowerCase()==pA.toLowerCase() || item_pagina.Status=="p" || item_pagina.Status=="f"){
				sigApartado = SCO.DATA.NEXGoNextBlock(aux);
					if (sigApartado!="") {
					tmpPagina=SCO.DATA.NEXFirst(sigApartado);
					}
				}
			}
			else{
				sigApartado = SCO.DATA.NEXGoNextBlock(aux);
				if (sigApartado!="") {
					tmpPagina=SCO.DATA.NEXFirst(sigApartado);
					//Control cambio de bloque
					for (j=i;j<profundidad-2;j++) tmpPagina = SCO.DATA.NEXFirst(tmpPagina);
				}
				i=i-1;
			}
		}
	}
	//alert("AVANZAR\nPagina siguiente de "+pA+" = "+tmpPagina)
	return tmpPagina.toLowerCase();
}

function _ExisteEnRango(arg){
	//alert(arg)
	var ans=arg;
	var rangoAry= new Array();
		//var temp="B1_1,B1_2,B1_3"
		//rangoAry=temp.split(","); //p.Ej: "B1_1,B1_2,B1_3"
	if(this.RagNav!=""){
		rangoAry=this.RagNav.split(","); //p.Ej: "B1_1,B1_2,B1_3"
		var contRango=rangoAry[0].split("_"); //p.Ej: B1,1
		var profRango=contRango.length;  //p.Ej: 2
		
		//Contruimos un array que contenga los elementos de arg, con la profundidada del rango profRango
		var elem=new Array(profRango);
		var tempPosition=arg.split("_");
			tempPosition[0]=tempPosition[0].substr(1,tempPosition[0].length);
	    	var strL=new String("B"); 
		   for (f=0;f<profRango;f++){
				if (f==0) strL=strL+tempPosition[f];
				else strL=strL+"_"+tempPosition[f];
				elem[f]=strL;
		   }
		var aLocalizar=elem[elem.length-1]
		//alert(aLocalizar);
		//var findEle=temp.search(aLocalizar);
		var aux=this.RagNav;
		var findEle=aux.toUpperCase().search(aLocalizar.toUpperCase());
		//alert(findEle)
		if (findEle==-1) ans="";
	}
	
	return ans;
}

function _getContents(arg){
	this.RagNav=arg;
	var aux=new Array();
	    aux=arg.split(",");
	var ans=new String("");
		for (var x=0;x<aux.length;x++){
			var temp=SCO.DATA.NEXStatus(aux[x]);
			if ((temp.toUpperCase()=="N")||(temp.toUpperCase()=="I")){
				ans=SCO.DATA.NEXFindItem(aux[x]);
				ans.Acceso();
				break;
			}
		}
		
		if (ans=="") {
			ans=SCO.DATA.NEXFindItem(aux[0]);
			ans.Acceso();
		}
}



function _getParcialContents(arg){
	this.RagNav=arg.split("|")[1];
	var tArg=arg.split("|")[0];
	var aux=new Array();
	    aux=tArg.split(",");
	var ans=new String("");
		for (var x=0;x<aux.length;x++){
			var temp=SCO.DATA.NEXStatus(aux[x]);
			if ((temp.toUpperCase()=="N")||(temp.toUpperCase()=="I")){
				ans=SCO.DATA.NEXFindItem(aux[x]);
				ans.Acceso();
				break;
			}
		}
		
		if (ans=="") {
			ans=SCO.DATA.NEXFindItem(aux[0]);
			ans.Acceso();
		}
}

AICC_NAV.prototype.Acceso=_Acceso;
AICC_NAV.prototype.IrPagina=_IrPagina;
AICC_NAV.prototype.getPaginacion=_getPaginacion;
AICC_NAV.prototype.Avanzar=_Avanzar;
AICC_NAV.prototype.Retroceder=_Retroceder;
AICC_NAV.prototype.ExisteEnRango=_ExisteEnRango;
AICC_NAV.prototype.getContents=_getContents;
AICC_NAV.prototype.getParcialContents=_getParcialContents;


libLoad[7]=true;