//Variables Globales:

    //Array que contendra todos los errores producidos:
var DataCliente=new Array ();

	//Hora inicio del Debugger:
var tmInit=new Date();

    //Determina si se ha de publicar el aviso de error
var avisos=true;
	//Determina si se ha de almacenar o no las acciones del usuario en el curso
var report=true;

/*******************************************************************************
**
** Constructor
** Function DebuggerJS()
** Inputs:  none
** Return:  none
**
** Description:
** Constructor del objeto debugger, gestionara la informacion de usuario y recopilara los datos de los errores que se haya producido
**
**
*******************************************************************************/
function DebuggerJS()
{
		this.DateStartAction=time(new Date());
		this.DateEndAction=new String("");
		this.TimeSpendAction=new String("");

}

/*******************************************************************************
**
** Private Function
** Function time(fecha)
** Inputs:  @fecha:String Fecha actual
** Return:  Fecha (dd/mm/aa) - Hora (hh:mm:ss) String 
**
** Description:
** Formatea la cadena de entrada fecha.
**
**
*******************************************************************************/
function time(fecha)
{
	var tm = new Date(fecha);
	var numDia = tm.getDay();
	var numMes = tm.getMonth();
	var numYear= tm.getFullYear();
	var numH = tm.getHours();
	var numM = tm.getMinutes();
	var numS = tm.getSeconds();
	if (numH<10) numH = "0"+numH;
	if (numM<10) numM = "0"+numM;
	if (numS<10) numS = "0"+numS;
	strTime = numDia+"-"+numMes+"-"+numYear+"   "+numH+":"+numM+":"+numS;	 
	return strTime;	 
}

/*******************************************************************************
**
** Private Function
** Function time()
** Inputs:  none
** Return:  Hora (hh:mm:ss) String 
**
** Description:
** Formatea la hora actual.
**
**
*******************************************************************************/
function timeHour()
{
	var tm = new Date();
	var numDia = tm.getDay();
	var numMes = tm.getMonth();
	var numYear= tm.getFullYear();
	var numH = tm.getHours();
	var numM = tm.getMinutes();
	var numS = tm.getSeconds();
	if (numH<10) numH = "0"+numH;
	if (numM<10) numM = "0"+numM;
	if (numS<10) numS = "0"+numS;
	strTime = numH+":"+numM+":"+numS;	 
	return strTime;	 
}




/*******************************************************************************
**
** Private Function
** Function timeSpend()
** Inputs:  none
** Return:  hora:String
**
** Description:
** Devuelve la diferencia horaria entre el inicio y el fin de la accion formativa.
**
**
*******************************************************************************/
function timeSpend()
{ 
     var temp = new String("");	 
	 // Fecha de desconexion
	 var tmFin = new Date();
	 
	 // Diferencia de hora entre el principio de la accion y el final de la accion
	 var tmDiff = Math.floor((tmFin.getTime()-tmInit.getTime())/1000);	
	 var arrAcumulat = new Array("00","00","00");
	 
	 tmDiff = parseInt(tmDiff)+parseInt(arrAcumulat[0])*3600+parseInt(arrAcumulat[1])*60+parseInt(arrAcumulat[2]);
	 var numH = Math.floor(tmDiff/3600);
	 tmDiff = tmDiff - numH*3600;
	 var numM = Math.floor(tmDiff/60);
	 tmDiff = tmDiff - numM*60;
	 if (numH<10) numH = "0"+numH;
	 if (numM<10) numM = "0"+numM;
	 if (tmDiff<10) tmDiff = "0"+tmDiff;
	 strTime = numH+":"+numM+":"+tmDiff;	 
	 return strTime;	 
}

/*******************************************************************************
**
** Public Function
** Function setError(arg)
** Inputs:  @arg:String Define el error que se a producido
** Return:  none 
**
** Description:
** Inserta en el Array de Datos, el Array que define el error que se ha producido.
** este Array de Error, se compone de dos elementos, la hora y la definicion del error
**
**
*******************************************************************************/
function setError(arg)
{
		var aux=new Array(3);
		aux[0]=0
		aux[1]=timeHour();
		aux[2]=arg;
		DataCliente.push(aux);
		
		if (avisos) alert(getLastError());
}


/*******************************************************************************
**
** Public Function
** Function getLastError()
** Inputs:  none
** Return:  ans:String 
**
** Description:
** Inserta en el Array de Datos, el string que define el error que se ha producido.
**
**
*******************************************************************************/
function getLastError()
{
		var ans=new String("");
		for (var z=DataCliente.length-1;z>=0;z++)
		{
			if (DataCliente[z][0]==0)
			{
			ans= "Error n:"+z+"  Se produjo un error a las :"+ DataCliente[z][1] + "  Con el siguiente mensaje:" + DataCliente[z][2];
			break;
			}
		}
		return ans;
}



/*******************************************************************************
**
** Public Function
** Function setAction(arg)
** Inputs:  @arg:String 
** Return:  none
**
** Description:
** Inserta en el Array de Datos, el string que define la accion que se ha producido.
**
**
*******************************************************************************/
function setAction(arg){
	if (report)
	{
	   var aux=new Array(3);
	   aux[0]=1
	   aux[1]=timeHour();
	   aux[2]=arg.toString();
	   DataCliente.push(aux);
	}
}

new DebuggerJS()
DebuggerJS.prototype.SetError=setError;
DebuggerJS.prototype.GetLastError=getLastError;
DebuggerJS.prototype.SetAction=setAction;


