//Libreria de Utilidades, se carga en todas las paginas via findAPI
var isInternetExplorer = navigator.appName.indexOf("Microsoft") != -1;
/*******************************************************************************
**
** Function  prepareFlash(name, path, width, height)
** Inputs:   @name: Nombre del Flash
			 @path: Ruta del Flash
			 @width:Ancho del Flash
			 @height:Alto del Flash
** Return:   @c:Objeto de Flash
**
** Description:
** Crea el Objeto Flash
**
*******************************************************************************/
function prepareFlash(path, name, width, height){
	
var c='<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" id="'+name+'" width="'+width+'" height="'+height+'" align="middle">';
	c+='<param name="allowScriptAccess" value="sameDomain" />';
	c+='<param name="movie" value="'+path+'" />';
	c+='<param name="menu" value="false" />';
	c+='<param name="quality" value="high" />';
	c+='<param name="wmode" value="transparent" />';
	c+='<param name="bgcolor" value="#ffffff" />';
	c+='<embed src="'+path+'" menu="false" quality="high" wmode="transparent" bgcolor="#ffffff" width="'+width+'" height="'+height+'" swLiveConnect=true id="'+name+'" name="'+name+'" align="middle" allowScriptAccess="sameDomain" type="application/x-shockwave-flash"/>';
	c+='</object>';
return (c);
}

/*******************************************************************************
**
** Function  Oculta(name)
** Inputs:   @name: Nombre de la Capa
** Return:   none
**
** Description:
** Oculta la capa name
**
*******************************************************************************/
function Oculta(name){
	document.getElementById(name).style.visibility="hidden";
}


/*******************************************************************************
**
** Function  Muestra(name)
** Inputs:   @name: Nombre de la Capa
** Return:   none
**
** Description:
** Muestra la capa name
**
*******************************************************************************/
function Muestra(name){
	if (document.getElementById(name)){
	document.getElementById(name).style.visibility="visible";
	}
}



/*******************************************************************************
**
** Function getFlashMovieObject(movieName)
** Inputs:   @movieName: Nombre del Flash
** Return:   @Object: El Objeto Flash
**
** Description:
** Devuelve el Objeto Flash para poder ejecutar metodos en Javascript:
**
*******************************************************************************/
function getFlashMovieObject(movieName)
{
  if (window.document[movieName]) 
  {
      return window.document[movieName];
  }
  if (navigator.appName.indexOf("Microsoft Internet")==-1)
  {
    if (document.embeds && document.embeds[movieName])
      return document.embeds[movieName]; 
  }
  else // if (navigator.appName.indexOf("Microsoft Internet")!=-1)
  {
    return document.getElementById(movieName);
  }
}

/*******************************************************************************
**
** Function  SetVariablesFlash(name, varName, varValue)
** Inputs:   @name: Nombre del Flash
			 @varName:Nombre de la variable
			 @varValue:Valor de la variable
** Return:   none
**
** Description:
** Establece un valor para una variable en una pelicula Flash
**
*******************************************************************************/
function SetVariablesFlash(name, varName, varValue){
  var demoObj=getFlashMovieObject(name)
      demoObj.SetVariable(varName, varValue);
}


/*******************************************************************************
**
** Function GetVariablesFlash(name, varName)
** Inputs:   @name: Nombre del Flash
			 @varName:Nombre de la variable
			 
** Return:   @varValue:Valor de la variable
**
** Description:
** Recuepera el valor de una variable en una pelicula Flash
**
*******************************************************************************/
function GetVariablesFlash(name, varName){
  var demoObj=getFlashMovieObject(name)
      varValue=demoObj.GetVariable(varName);
      return varValue;
}
/*******************************************************************************
**
** Function  RefrescoFlash (name)
** Inputs:   @name: Nombre del Flash
** Return:   none
**
** Description:
** Refresca una pelicula Flash
**
*******************************************************************************/
function RefrescoFlash (name){
   var demoObj=getFlashMovieObject(name)
       demoObj.Rewind();
   	   demoObj.Play();  
}


/*******************************************************************************
**
** Function  RebobinaFlash (name)
** Inputs:   @name: Nombre del Flash
** Return:   none
**
** Description:
** Lleval al primer KeyFrame una pelicula Flash
**
*******************************************************************************/
function RebobinaFlash (name){
   var demoObj=getFlashMovieObject(name)
       demoObj.Rewind();
}

/*******************************************************************************
**
** Function  EjecutaFlash(name, movieClip, keyLabel)
** Inputs:   @name: Nombre del Flash;
			 @movieClip: _root o cualquier otro.
			 @keyLable: Nombre de la etiqueta a llamar
** Return:   none
**
** Description:
** Lleval al primer KeyFrame una pelicula Flash
**
*******************************************************************************/
function EjecutaFlash(name, movieClip, keyLabel){
	 try{
	 var demoObj=getFlashMovieObject(name)
	 	 demoObj.TCallLabel(movieClip, keyLabel);
	 }
	 catch (exception) {
	 }
}

/*******************************************************************************
**
** Function  EjecutaFlash(name, movieClip, keyLabel)
** Inputs:   @name: Nombre del Flash;
			 @movieClip: _root o cualquier otro.
			 @keyLable: Nombre de la etiqueta a llamar
** Return:   none
**
** Description:
** Lleval al primer KeyFrame una pelicula Flash
**
*******************************************************************************/
function ObjFlash(name, movieClip){
	 try{
	 var demoObj=getFlashMovieObject(name)
	 	 demoObj.TCallFrame(movieClip, 1);
	 }
	 catch (exception) {
	 }
}


function createImaFlash(layerFL,nameFl, sizeW, sizeH){
var esNN=false;
if (navigator.appName=="Netscape") esNN=true;
if (!esNN){
	AC_FL_RunContentCont(
	    "id","imaFL", 
	    "movie", nameFl.split(".swf")[0],
	    "width", sizeW,
	    "height",sizeH,
	    "allowScriptAccess", "sameDomain",
	    "menu", "false",
	    "FlashVars", "",
	    "quality","high",
	    "wmode" ,"transparent",
	    "bgcolor","#ffffff" ,
	    "src", nameFl.split(".swf")[0],
	    "swLiveConnect", "true",
	    "name","imaFL",
	    "align","middle",
	    "layerFL", layerFL
	);
	
}
else{
document.getElementById(layerFL).innerHTML=prepareFlash(nameFl, "imaFL", sizeW, sizeH);
}
}