var aux = "";	  
var cookieInt = null;
var cookieCore = null;
var tmInit = null; //tiempo inicial de conexion

var errorCode=0;


function recrearCookie(path)
{
   // Crear cookie que guarda informacion de interacciones   
   cookieInt = new Cookie(document,"NexeInteractions",240,path);
   
      aux="";
	  cookieInt._count = 0;
	  cookieInt.data = ""; //Id, Objectives, time, type, correct_responses, weighting, student_response, result, latency   	  
	  cookieInt.store();
   
   // Crear cookie que guarda informacion de Objetivos 
   cookieObj = new Cookie(document,"NexeObjectives",240,path);
      aux="";
	  cookieObj._count = 0;
	  cookieObj.data = ""; //Id, Score {raw, min, max}, Status  	  
	  cookieObj.store();
   

   
   //Crear cookie que guarda informacion del alumno del curso 
   cookieCore = new Cookie(document,"NexeCore",240,path);
         
      cookieCore.student_id = 0;
	  cookieCore.student_name = "";
	  cookieCore.lesson_location = "";
	  cookieCore.launch_data = "";
	  cookieCore.suspend_data = "";		  
	  cookieCore.status = "not attempted";  	  
	  cookieCore.score = 0;
	  cookieCore.mastery_score = "";	  	   	  	  	   
	  cookieCore.idioma="es";
	  cookieCore.perfil="";
	  cookieCore.store();
	  
   if (typeof(cookieCore.totalTime)=="undefined") cookieCore.totalTime = "";
   cookieCore.store();
   
}


/**************************************************/
/*               Inicializar el core              */
/**************************************************/
 

function crearCookie(path)
{
   // Crear cookie que guarda informacion de interacciones   
   cookieInt = new Cookie(document,"NexeInteractions",240,path);
   if (!cookieInt.load())    
   { 
      aux="";
	  cookieInt._count = 0;
	  cookieInt.data = ""; //Id, Objectives, time, type, correct_responses, weighting, student_response, result, latency   	  
	  cookieInt.store();
   }   
   
   // Crear cookie que guarda informacion de Objetivos 
   cookieObj = new Cookie(document,"NexeObjectives",240,path);
   if (!cookieObj.load())    
   { 
      aux="";
	  cookieObj._count = 0;
	  cookieObj.data = ""; //Id, Score {raw, min, max}, Status  	  
	  cookieObj.store();
   }   
   

   
   //Crear cookie que guarda informacion del alumno del curso 
   cookieCore = new Cookie(document,"NexeCore",240,path);
   if (!cookieCore.load())    
   { 
         
      cookieCore.student_id = 0;
	  cookieCore.student_name = "";
	  cookieCore.lesson_location = "";
	  cookieCore.launch_data = "";
	  cookieCore.suspend_data = "";		  
	  cookieCore.status = "not attempted";  	  
	  cookieCore.score = 0;
	  cookieCore.mastery_score = "";
	  cookieCore.idioma="es";
	  cookieCore.perfil="";
	  cookieCore.store();
   }
   if (typeof(cookieCore.totalTime)=="undefined") cookieCore.totalTime = "";
   
   cookieCore.store();
   
}

/************************************************/
/*         Reiniciar cookie                      */
/************************************************/

function reiniciarCookie( cookie )
{
    cookie.remove();
}

/********************************************/
/* Recuperar informacion de las iteraciones */
/********************************************/
function recuperarInt ( par )
{
   var temp1 = new String(par);
   var temp2 = new String(cookieInt.testdata);
   var id = "";
   var count = 0;
   var parametro ="";
   var contenido ="";
   
   var i=0;
   var j=0;
   
   intSplit = temp1.split(".");
   count = intSplit[2];   
   parametro  =  intSplit[3];
   
   id = "_" + count + ",";
   
   testDataSplit  = temp2.split(";"); 
   
   for( i=0; i < testDataSplit.length - 1; i++)
   {
        if ( testDataSplit[i].search(id) != -1)
		{		    
			j = i;			
			break;
		}
   }
   contenido = testDataSplit[j].split(",");
        
   switch (parametro)
   {
        case "id":
	  	{   
            id = contenido[0].split("_");
			
			parametro ="";
			for (i = 0; i < id.length-1 ;i++ )
			{
			   parametro = parametro +  id[i] +"_"; 			   
			}	
				
			parametro = parametro.substr(0,parametro.length-1);						
			return parametro;
			break;	        		
        }
		
		case "type":
		{
		    parametro = contenido[1];
			return parametro;
			break;   			
		}
		
		case "student_response":
		{
		    parametro = contenido[2];
			return parametro;
			break;   		
		}
		
		case "result":
		{
		    parametro = contenido[3];
			return parametro;
			break;   
		}		
		
		default:
		{
		    parametro = "";
			return parametro;		
		}
   }
}



function AICC_API()
{		
	  crearCookie();	  
}

/********************************************/
/* Guadar tiempo total de conexion          */
/********************************************/
function _guardarTiempo()
{ 
     var temp = new String("");	 
	 // Fecha de desconexion
	 var tmFin = new Date();
	 
	 // Diferencia de hora entre el principio de la sesion y el final de la sesion
	 var tmDiff = Math.floor((tmFin.getTime()-tmInit.getTime())/1000);	
	 var arrAcumulat = new Array("00","00","00");
	 var acumulat = _LMSGetValue("totalTime");
	 if (typeof acumulat!="undefined") 
	 {
		arrAcumulat = acumulat.split(":");
		if (arrAcumulat.length<3) 
		{
			arrAcumulat[0]="00";
			arrAcumulat[1]="00";
			arrAcumulat[2]="00";
		}
	 }
	 tmDiff = parseInt(tmDiff)+parseInt(arrAcumulat[0])*3600+parseInt(arrAcumulat[1])*60+parseInt(arrAcumulat[2]);
	 var numH = Math.floor(tmDiff/3600);
	 tmDiff = tmDiff - numH*3600;
	 var numM = Math.floor(tmDiff/60);
	 tmDiff = tmDiff - numM*60;
	 if (numH<10) numH = "0"+numH;
	 if (numM<10) numM = "0"+numM;
	 if (tmDiff<10) tmDiff = "0"+tmDiff;
	 strTime = numH+":"+numM+":"+tmDiff;	 
	 return strTime;	 
}

function _LMSGetValue(parameter)
{
    //setAction("GetValue("+parameter+")");
	switch (parameter)
	{
	     
		case "suspend_data":
		 {   
		     errorCode=0
		     return cookieCore.suspend_data; 
		     break;
		 }
		 case "launch_data":
		 {
		     errorCode=0
		     	   return course_structure
		 	 //return cookieCore.launch_data; 
		     break;
        	 }
        case "student_name":
		 {   
		     errorCode=0
		     return cookieCore.student_name; 
		     break;
		 }

         	case "lesson_location":
		 {
		     errorCode=0
		      	  //return cookieCore.suspend_data; 
		 	 return cookieCore.lesson_location; 
		     break;
         	}
         
         case "status":
         {
             errorCode=0
		 	 return cookieCore.status; 
		     break;
         }
  		
  		case "score":
         {
             errorCode=0
		 	 return cookieCore.score; 
		     break;
         }
        
        case "mastery_score":
         {
             errorCode=0
		 	 return cookieCore.mastery_score; 
		     break;
         }
         
        case "idioma":
         {
             errorCode=0
		 	 return cookieCore.idioma; 
		     break;
         }
        case "perfil":
         {
             errorCode=0
		 	 return cookieCore.perfil; 
		     break;
         }
        case "objetivos":{
        	errorCode=0;
        	return cookieObj.data;
        	break;
        }
        
		 default: 
		 {
		 	alert ("Parametro incorrecto:" + parameter + " no esta definido");
            errorCode=404;
		 	//SetError(_LMSGetErrorString(errorCode))
            return "false"
            break;
		 }  
	}   	
}

function _LMSSetValue (parameter,value)
{
    //setAction("SetValue("+parameter+","+value+")")
 	// Parametro a actualizar;
	 
    switch ( parameter)
	{
	     
		 case "suspend_data":
		 {
		     cookieCore.suspend_data= value;
		     cookieCore.store();
		     errorCode=0;
			 return true;
		     break;
		 }
		  case "student_name":
		 {
		     cookieCore.student_name= value;
		     cookieCore.store();
		     errorCode=0;
			 return true;
		     break;
		 }
		 case "launch_data":
		 {
		 	 errorCode=404;
		 	 //SetError(_LMSGetErrorString(errorCode))
		     return false;
			 break;
		 }
		 
         	case "status":
		 {
		     cookieCore.status= value;
		     cookieCore.store();
		     errorCode=0;
			 return true;
		     break;
		 }
		 
		 case "score":
		 {
		     cookieCore.score= value;
		     cookieCore.store();
		     errorCode=0;
			 return true;
		     break;
		 }
		 
		  case "idioma":
		 {
		     cookieCore.idioma= value;
		     cookieCore.store();
		     errorCode=0;
			 return true;
		     break;
		 }
		 
		 case "perfil":
		 {
		     cookieCore.perfil= value;
		     cookieCore.store();
		     errorCode=0;
			 return true;
		     break;
		 }
		 case "lesson_location":
		 {
		     cookieCore.lesson_location= value;
		     //cookieCore.suspend_data=value;
		     cookieCore.store();
		     errorCode=0;
			 return true;
		     break;
		 }
         
         case "objetivos":{
         	cookieObj.data=value
         	cookieObj.store();
        	errorCode=0;
        	return true;
        	break;
        }

         
         case "mastery_score":
         {
             errorCode=404;
		 	 //SetError(_LMSGetErrorString(errorCode))
		     return false;
			 break;
         }

	    default: 
		 {
		 	alert ("Parametro incorrecto:" + parameter + " no esta definido");
            errorCode=404;
		 	//SetError(_LMSGetErrorString(errorCode))
            return "false"
            break;
		 }  
	
	}     
}

function _LMSCommit(parameter)
{     
   return "true";
}

function _LMSInitialize(parameter)
{
    
     tmInit = new Date();         
	 if (cookieCore.status == "not attempted")
	 {
	 		cookieCore.status = "incomplete"; 			 			
	 		cookieCore.store();				
	 }
	 return "true";
}

function _LMSFinish(parameter)
{
  //CERRAR LA COMUNICACIN Y ASEGURARSE QUE SE GRABARON TODOS LOS DATOS 
  return "true";
}

function _LMSGetErrorString (parameter)
{
   switch (parameter)
	{
	      case 404:
		 {
		 	msg="Data Model Element Is Read Only"
		 	return  msg
		 	break;
		 }
	}
}

function _LMSGetLastError ()
{
   return errorCode; 
}

function _LMSGetDiagnostic(parameter)
{

}

new AICC_API();
AICC_API.prototype.LMSGetValue = _LMSGetValue;
AICC_API.prototype.LMSSetValue = _LMSSetValue;
AICC_API.prototype.LMSCommit = _LMSCommit;
AICC_API.prototype.LMSInitialize = _LMSInitialize;
AICC_API.prototype.LMSFinish = _LMSFinish;
AICC_API.prototype.LMSGetErrorString = _LMSGetErrorString;
AICC_API.prototype.LMSGetLastError = _LMSGetLastError;
AICC_API.prototype.LMSGetDiagnostic = _LMSGetDiagnostic;
AICC_API.prototype.guardarTiempo = _guardarTiempo;
libLoad[1]=true;